<!DOCTYPE html
  PUBLIC "-//W3C//DTD XHTML 1.0 Strict//EN"
  "DTD/xhtml1-strict.dtd">
<html>
  <head>
    <title>API docs for &ldquo;kiwi.model.Model&rdquo;</title>
    <meta content="text/html;charset=utf-8" http-equiv="Content-Type" />
    <link href="apidocs.css" type="text/css" rel="stylesheet" />
    
    
  </head>
  <body>
    <h1 class="class">Class k.m.Model:</h1>
    <p>
      <span id="part">Part of <a href="kiwi.html">kiwi</a>.<a href="kiwi.model.html">model</a></span>
      
      <a href="classIndex.html#kiwi.model.Model">View In Hierarchy</a>
    </p>
    <div>
      <p>Known subclasses: <a href="kiwi.model.PickledModel.html">kiwi.model.PickledModel</a></p>
    </div>
    <div>The Model is a mixin to be used by domain classes when attached to 
Proxies.  It also provides autonotification of changes to the attached 
proxies. Note that if using setters, a specific call to notify_proxies() 
may be necessary; see the doc for __setattr__.
<table class="fieldTable"></table></div>
    
    
    <div id="splitTables">
      <table class="children sortable" id="id355">
  
  
  
  
  <tr class="method">
    
    
    <td>Method</td>
    <td><a href="kiwi.model.Model.html#__init__">__init__</a></td>
    <td><span class="undocumented">Undocumented</span></td>
  </tr><tr class="method">
    
    
    <td>Method</td>
    <td><a href="kiwi.model.Model.html#ensure_init">ensure_init</a></td>
    <td><span>Sets up the variables so the Model's getattr hook and proxy
</span></td>
  </tr><tr class="method">
    
    
    <td>Method</td>
    <td><a href="kiwi.model.Model.html#disable_autonotify">disable_autonotify</a></td>
    <td><span>disable automatic notification to proxies based on __setattr__.
</span></td>
  </tr><tr class="method">
    
    
    <td>Method</td>
    <td><a href="kiwi.model.Model.html#notify_proxies">notify_proxies</a></td>
    <td><span>Notify proxies that an attribute value has changed.
</span></td>
  </tr><tr class="method">
    
    
    <td>Method</td>
    <td><a href="kiwi.model.Model.html#register_proxy_for_attribute">register_proxy_for_attribute</a></td>
    <td><span>Attach a proxy to an attribute. The proxy will be notified of
</span></td>
  </tr><tr class="method">
    
    
    <td>Method</td>
    <td><a href="kiwi.model.Model.html#unregister_proxy_for_attribute">unregister_proxy_for_attribute</a></td>
    <td><span>Detach a proxy from an attribute.
</span></td>
  </tr><tr class="method">
    
    
    <td>Method</td>
    <td><a href="kiwi.model.Model.html#unregister_proxy">unregister_proxy</a></td>
    <td><span>Deattach a proxy completely from the model
</span></td>
  </tr><tr class="method">
    
    
    <td>Method</td>
    <td><a href="kiwi.model.Model.html#flush_proxies">flush_proxies</a></td>
    <td><span>Removes all proxies attached to Model
</span></td>
  </tr><tr class="method">
    
    
    <td>Method</td>
    <td><a href="kiwi.model.Model.html#block_proxy">block_proxy</a></td>
    <td><span>Temporarily block a proxy from receiving any notification. See
</span></td>
  </tr><tr class="method">
    
    
    <td>Method</td>
    <td><a href="kiwi.model.Model.html#unblock_proxy">unblock_proxy</a></td>
    <td><span>Re-enable notifications to a proxy
</span></td>
  </tr><tr class="method">
    
    
    <td>Method</td>
    <td><a href="kiwi.model.Model.html#__setattr__">__setattr__</a></td>
    <td><span>A special setattr hook that notifies the registered proxies that
</span></td>
  </tr>
  
</table>
      
      
    </div>
    
    
    
    <div class="function">
        <a name="kiwi.model.Model.__init__"></a>
        <a name="__init__"></a>
        <div class="functionHeader">
        
        def __init__(self):
        
      </div>
        <div class="functionBody">
          <div class="interfaceinfo">overridden in <a href="kiwi.model.PickledModel.html">kiwi.model.PickledModel</a></div>
          <div class="undocumented">Undocumented</div>
        </div>
      </div><div class="function">
        <a name="kiwi.model.Model.ensure_init"></a>
        <a name="ensure_init"></a>
        <div class="functionHeader">
        
        def ensure_init(self):
        
      </div>
        <div class="functionBody">
          
          <div>Sets up the variables so the Model's getattr hook and proxy notification
work properly.
<table class="fieldTable"></table></div>
        </div>
      </div><div class="function">
        <a name="kiwi.model.Model.disable_autonotify"></a>
        <a name="disable_autonotify"></a>
        <div class="functionHeader">
        
        def disable_autonotify(self):
        
      </div>
        <div class="functionBody">
          
          <div>disable automatic notification to proxies based on __setattr__. All 
changes to the model must be followed by a call to notify_proxies() to 
allow the proxies to notice the change.
<table class="fieldTable"></table></div>
        </div>
      </div><div class="function">
        <a name="kiwi.model.Model.notify_proxies"></a>
        <a name="notify_proxies"></a>
        <div class="functionHeader">
        
        def notify_proxies(self, attr):
        
      </div>
        <div class="functionBody">
          
          <div>Notify proxies that an attribute value has changed.
<table class="fieldTable"></table></div>
        </div>
      </div><div class="function">
        <a name="kiwi.model.Model.register_proxy_for_attribute"></a>
        <a name="register_proxy_for_attribute"></a>
        <div class="functionHeader">
        
        def register_proxy_for_attribute(self, attr, proxy):
        
      </div>
        <div class="functionBody">
          
          <div>Attach a proxy to an attribute. The proxy will be notified of changes to
that particular attribute (my means of Proxy.notify()).
<table class="fieldTable"></table></div>
        </div>
      </div><div class="function">
        <a name="kiwi.model.Model.unregister_proxy_for_attribute"></a>
        <a name="unregister_proxy_for_attribute"></a>
        <div class="functionHeader">
        
        def unregister_proxy_for_attribute(self, attr, proxy):
        
      </div>
        <div class="functionBody">
          
          <div>Detach a proxy from an attribute.
<table class="fieldTable"></table></div>
        </div>
      </div><div class="function">
        <a name="kiwi.model.Model.unregister_proxy"></a>
        <a name="unregister_proxy"></a>
        <div class="functionHeader">
        
        def unregister_proxy(self, proxy):
        
      </div>
        <div class="functionBody">
          
          <div>Deattach a proxy completely from the model
<table class="fieldTable"></table></div>
        </div>
      </div><div class="function">
        <a name="kiwi.model.Model.flush_proxies"></a>
        <a name="flush_proxies"></a>
        <div class="functionHeader">
        
        def flush_proxies(self):
        
      </div>
        <div class="functionBody">
          
          <div>Removes all proxies attached to Model
<table class="fieldTable"></table></div>
        </div>
      </div><div class="function">
        <a name="kiwi.model.Model.block_proxy"></a>
        <a name="block_proxy"></a>
        <div class="functionHeader">
        
        def block_proxy(self, proxy):
        
      </div>
        <div class="functionBody">
          
          <div>Temporarily block a proxy from receiving any notification. See 
unblock_proxy()
<table class="fieldTable"></table></div>
        </div>
      </div><div class="function">
        <a name="kiwi.model.Model.unblock_proxy"></a>
        <a name="unblock_proxy"></a>
        <div class="functionHeader">
        
        def unblock_proxy(self, proxy):
        
      </div>
        <div class="functionBody">
          
          <div>Re-enable notifications to a proxy
<table class="fieldTable"></table></div>
        </div>
      </div><div class="function">
        <a name="kiwi.model.Model.__setattr__"></a>
        <a name="__setattr__"></a>
        <div class="functionHeader">
        
        def __setattr__(self, attr, value):
        
      </div>
        <div class="functionBody">
          
          <div><p>A special setattr hook that notifies the registered proxies that the 
model has changed. Work around it setting attributes directly to 
self.__dict__.</p>
Note that setattr() assumes that the name of the attribute being changed
and the proxy attribute are the same. If this is not the case (as may 
happen when using setters) you must call notify_proxies() manually from the
subclass' setter.
<table class="fieldTable"></table></div>
        </div>
      </div>
    
    <address>
      <a href="index.html">API Documentation</a> for Kiwi, generated by <a href="http://codespeak.net/~mwh/pydoctor/">pydoctor</a> at 2008-05-29 16:06:17.
    </address>
  </body>
</html>